<html>
<head>
<title>OGRE: OgreViewport.h Source File - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.5.3 -->
<div class="tabs">
  <ul>
    <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
    <li><a href="namespaces.html"><span>Namespaces</span></a></li>
    <li><a href="classes.html"><span>Classes</span></a></li>
    <li class="current"><a href="files.html"><span>Files</span></a></li>
    <li><a href="dirs.html"><span>Directories</span></a></li>
    <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
  </ul>
</div>
<div class="nav">
<a class="el" href="dir_d6c9b501d36b850bf0bac687671293db.html">OgreMain</a>&nbsp;&raquo&nbsp;<a class="el" href="dir_f35e1e76cd4423745a1cccb1f171d4e3.html">include</a></div>
<h1>OgreViewport.h</h1><a href="OgreViewport_8h.html">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00003"></a>00003 <span class="comment">This source file is part of OGRE</span>
<a name="l00004"></a>00004 <span class="comment">    (Object-oriented Graphics Rendering Engine)</span>
<a name="l00005"></a>00005 <span class="comment">For the latest info, see http://www.ogre3d.org/</span>
<a name="l00006"></a>00006 <span class="comment"></span>
<a name="l00007"></a>00007 <span class="comment">Copyright (c) 2000-2006 Torus Knot Software Ltd</span>
<a name="l00008"></a>00008 <span class="comment">Also see acknowledgements in Readme.html</span>
<a name="l00009"></a>00009 <span class="comment"></span>
<a name="l00010"></a>00010 <span class="comment">This program is free software; you can redistribute it and/or modify it under</span>
<a name="l00011"></a>00011 <span class="comment">the terms of the GNU Lesser General Public License as published by the Free Software</span>
<a name="l00012"></a>00012 <span class="comment">Foundation; either version 2 of the License, or (at your option) any later</span>
<a name="l00013"></a>00013 <span class="comment">version.</span>
<a name="l00014"></a>00014 <span class="comment"></span>
<a name="l00015"></a>00015 <span class="comment">This program is distributed in the hope that it will be useful, but WITHOUT</span>
<a name="l00016"></a>00016 <span class="comment">ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS</span>
<a name="l00017"></a>00017 <span class="comment">FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.</span>
<a name="l00018"></a>00018 <span class="comment"></span>
<a name="l00019"></a>00019 <span class="comment">You should have received a copy of the GNU Lesser General Public License along with</span>
<a name="l00020"></a>00020 <span class="comment">this program; if not, write to the Free Software Foundation, Inc., 59 Temple</span>
<a name="l00021"></a>00021 <span class="comment">Place - Suite 330, Boston, MA 02111-1307, USA, or go to</span>
<a name="l00022"></a>00022 <span class="comment">http://www.gnu.org/copyleft/lesser.txt.</span>
<a name="l00023"></a>00023 <span class="comment"></span>
<a name="l00024"></a>00024 <span class="comment">You may alternatively use this source under the terms of a specific version of</span>
<a name="l00025"></a>00025 <span class="comment">the OGRE Unrestricted License provided you have obtained such a license from</span>
<a name="l00026"></a>00026 <span class="comment">Torus Knot Software Ltd.</span>
<a name="l00027"></a>00027 <span class="comment">-----------------------------------------------------------------------------</span>
<a name="l00028"></a>00028 <span class="comment">*/</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifndef __Viewport_H__</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#define __Viewport_H__</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="preprocessor">#include "<a class="code" href="OgrePrerequisites_8h.html">OgrePrerequisites.h</a>"</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include "<a class="code" href="OgreCommon_8h.html">OgreCommon.h</a>"</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include "<a class="code" href="OgreColourValue_8h.html">OgreColourValue.h</a>"</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>Ogre {
<a name="l00050"></a><a class="code" href="classOgre_1_1Viewport.html">00050</a>     <span class="keyword">class </span><a class="code" href="OgrePlatform_8h.html#20566b1253bae200372ed9162489a663">_OgreExport</a> <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052     <span class="keyword">public</span>:
<a name="l00075"></a>00075         <a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>(
<a name="l00076"></a>00076             <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* camera,
<a name="l00077"></a>00077             <a class="code" href="classOgre_1_1RenderTarget.html" title="A &amp;#39;canvas&amp;#39; which can receive the results of a rendering operation.">RenderTarget</a>* target,
<a name="l00078"></a>00078             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top,
<a name="l00079"></a>00079             <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height,
<a name="l00080"></a>00080             <span class="keywordtype">int</span> ZOrder);
<a name="l00081"></a>00081 
<a name="l00084"></a>00084         <span class="keyword">virtual</span> ~<a class="code" href="classOgre_1_1Viewport.html" title="An abstraction of a viewport, i.e.">Viewport</a>();
<a name="l00085"></a>00085 
<a name="l00093"></a>00093         <span class="keywordtype">void</span> _updateDimensions(<span class="keywordtype">void</span>);
<a name="l00094"></a>00094 
<a name="l00097"></a>00097         <span class="keywordtype">void</span> update(<span class="keywordtype">void</span>);
<a name="l00098"></a>00098 
<a name="l00101"></a>00101         <a class="code" href="classOgre_1_1RenderTarget.html" title="A &amp;#39;canvas&amp;#39; which can receive the results of a rendering operation.">RenderTarget</a>* getTarget(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00102"></a>00102 
<a name="l00105"></a>00105         <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* getCamera(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00106"></a>00106 
<a name="l00108"></a>00108         <span class="keywordtype">void</span> setCamera(<a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* cam);
<a name="l00109"></a>00109 
<a name="l00111"></a>00111         <span class="keywordtype">int</span> getZOrder(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00115"></a>00115         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getLeft(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00116"></a>00116 
<a name="l00120"></a>00120         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getTop(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00126"></a>00126         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getWidth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00131"></a>00131         <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> getHeight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00136"></a>00136         <span class="keywordtype">int</span> getActualLeft(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00141"></a>00141         <span class="keywordtype">int</span> getActualTop(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00145"></a>00145         <span class="keywordtype">int</span> getActualWidth(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00150"></a>00150         <span class="keywordtype">int</span> getActualHeight(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00151"></a>00151 
<a name="l00164"></a>00164         <span class="keywordtype">void</span> setDimensions(<a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> left, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> top, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> width, <a class="code" href="namespaceOgre.html#a3a7b6dfb905e6572d62f0dfa3d4274d" title="Software floating point type.">Real</a> height);
<a name="l00165"></a>00165 
<a name="l00169"></a>00169         <span class="keywordtype">void</span> setBackgroundColour(<span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; colour);
<a name="l00170"></a>00170 
<a name="l00173"></a>00173         <span class="keyword">const</span> <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a>&amp; getBackgroundColour(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00174"></a>00174 
<a name="l00184"></a>00184         <span class="keywordtype">void</span> setClearEveryFrame(<span class="keywordtype">bool</span> clear, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> buffers = <a class="code" href="namespaceOgre.html#0206520b2d2647504c13017f2aaf474137afd2c8cf628f3057c09eac0529a466">FBT_COLOUR</a> | <a class="code" href="namespaceOgre.html#0206520b2d2647504c13017f2aaf47413466d3d0081023a40db64a4cd389fe40">FBT_DEPTH</a>);
<a name="l00185"></a>00185 
<a name="l00188"></a>00188         <span class="keywordtype">bool</span> getClearEveryFrame(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00189"></a>00189 
<a name="l00191"></a>00191         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> getClearBuffers(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00192"></a>00192 
<a name="l00200"></a><a class="code" href="classOgre_1_1Viewport.html#8e8577fd81c45b05de880106f364a281">00200</a>         <span class="keywordtype">void</span> setMaterialScheme(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; schemeName)
<a name="l00201"></a>00201         { mMaterialSchemeName = schemeName; }
<a name="l00202"></a>00202         
<a name="l00205"></a><a class="code" href="classOgre_1_1Viewport.html#6a7957a8f88824cb9dffad4627aed0c2">00205</a>         <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getMaterialScheme(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00206"></a>00206 <span class="keyword">        </span>{ <span class="keywordflow">return</span> mMaterialSchemeName; }
<a name="l00207"></a>00207 
<a name="l00210"></a>00210         <span class="keywordtype">void</span> getActualDimensions(
<a name="l00211"></a>00211             <span class="keywordtype">int</span> &amp;left, <span class="keywordtype">int</span> &amp;top, <span class="keywordtype">int</span> &amp;width, <span class="keywordtype">int</span> &amp;height ) <span class="keyword">const</span>;
<a name="l00212"></a>00212 
<a name="l00213"></a>00213         <span class="keywordtype">bool</span> _isUpdated(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00214"></a>00214         <span class="keywordtype">void</span> _clearUpdatedFlag(<span class="keywordtype">void</span>);
<a name="l00215"></a>00215 
<a name="l00218"></a>00218         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getNumRenderedFaces(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00219"></a>00219 
<a name="l00222"></a>00222         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _getNumRenderedBatches(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00223"></a>00223 
<a name="l00234"></a>00234         <span class="keywordtype">void</span> setOverlaysEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00235"></a>00235 
<a name="l00238"></a>00238         <span class="keywordtype">bool</span> getOverlaysEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00239"></a>00239 
<a name="l00250"></a>00250         <span class="keywordtype">void</span> setSkiesEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00251"></a>00251 
<a name="l00254"></a>00254         <span class="keywordtype">bool</span> getSkiesEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00255"></a>00255 
<a name="l00264"></a>00264         <span class="keywordtype">void</span> setShadowsEnabled(<span class="keywordtype">bool</span> enabled);
<a name="l00265"></a>00265 
<a name="l00268"></a>00268         <span class="keywordtype">bool</span> getShadowsEnabled(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00279"></a><a class="code" href="classOgre_1_1Viewport.html#d5a4fe00ee05861c157bf63e78e1c2b0">00279</a>         <span class="keywordtype">void</span> setVisibilityMask(<a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> mask) { mVisibilityMask = mask; }
<a name="l00280"></a>00280 
<a name="l00284"></a><a class="code" href="classOgre_1_1Viewport.html#84e9c01f4e8e62422be4fda269dd54cd">00284</a>         <a class="code" href="namespaceOgre.html#b6e842a18caf062ed73a5d3badd0dd4c">uint</a> getVisibilityMask(<span class="keywordtype">void</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> mVisibilityMask; }
<a name="l00285"></a>00285 
<a name="l00298"></a>00298         <span class="keyword">virtual</span> <span class="keywordtype">void</span> setRenderQueueInvocationSequenceName(<span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; sequenceName);
<a name="l00300"></a>00300         <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a>&amp; getRenderQueueInvocationSequenceName(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00302"></a>00302         <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>* _getRenderQueueInvocationSequence(<span class="keywordtype">void</span>);
<a name="l00303"></a>00303 
<a name="l00304"></a>00304     <span class="keyword">protected</span>:
<a name="l00305"></a><a class="code" href="classOgre_1_1Viewport.html#36698bf38ccd2f3352acdfa87f872bc8">00305</a>         <a class="code" href="classOgre_1_1Camera.html" title="A viewpoint from which the scene will be rendered.">Camera</a>* mCamera;
<a name="l00306"></a><a class="code" href="classOgre_1_1Viewport.html#30e4c768a1a5ac98c6b1eae1aa1936a7">00306</a>         <a class="code" href="classOgre_1_1RenderTarget.html" title="A &amp;#39;canvas&amp;#39; which can receive the results of a rendering operation.">RenderTarget</a>* mTarget;
<a name="l00307"></a>00307         <span class="comment">// Relative dimensions, irrespective of target dimensions (0..1)</span>
<a name="l00308"></a><a class="code" href="classOgre_1_1Viewport.html#afd8a3dc0df1d03cbab1810379c66475">00308</a>         <span class="keywordtype">float</span> mRelLeft, mRelTop, mRelWidth, mRelHeight;
<a name="l00309"></a>00309         <span class="comment">// Actual dimensions, based on target dimensions</span>
<a name="l00310"></a><a class="code" href="classOgre_1_1Viewport.html#4ff8c7f41b09c379d3b58b662a3efea8">00310</a>         <span class="keywordtype">int</span> mActLeft, mActTop, mActWidth, mActHeight;
<a name="l00312"></a><a class="code" href="classOgre_1_1Viewport.html#682fb477e687507fd715f2dfd29c397c">00312</a>         <span class="keywordtype">int</span> mZOrder;
<a name="l00314"></a><a class="code" href="classOgre_1_1Viewport.html#36865f1dadd8c420534b75d908d102be">00314</a>         <a class="code" href="classOgre_1_1ColourValue.html" title="Class representing colour.">ColourValue</a> mBackColour;
<a name="l00315"></a><a class="code" href="classOgre_1_1Viewport.html#cfd2ea86e54aee8f02f41e1fb5dc3b9b">00315</a>         <span class="keywordtype">bool</span> mClearEveryFrame;
<a name="l00316"></a><a class="code" href="classOgre_1_1Viewport.html#c6f276653f755783c0c7a9553eae8e66">00316</a>         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mClearBuffers;
<a name="l00317"></a><a class="code" href="classOgre_1_1Viewport.html#b709605fc7d6015af896b43cc71831ba">00317</a>         <span class="keywordtype">bool</span> mUpdated;
<a name="l00318"></a><a class="code" href="classOgre_1_1Viewport.html#628f58393bf84c4fb404421919b6f198">00318</a>         <span class="keywordtype">bool</span> mShowOverlays;
<a name="l00319"></a><a class="code" href="classOgre_1_1Viewport.html#de5f6bd07d4902efb3e087c73a57ecab">00319</a>         <span class="keywordtype">bool</span> mShowSkies;
<a name="l00320"></a><a class="code" href="classOgre_1_1Viewport.html#508ab72bd9d5739210a6db2da0cbbc39">00320</a>         <span class="keywordtype">bool</span> mShowShadows;
<a name="l00321"></a><a class="code" href="classOgre_1_1Viewport.html#9af0d0c0aca7cfedae4bd2b8fef0c333">00321</a>         <a class="code" href="namespaceOgre.html#df2a0cf2e77143b5ee1d38a75e289545">uint32</a> mVisibilityMask;
<a name="l00322"></a>00322         <span class="comment">// Render queue invocation sequence name</span>
<a name="l00323"></a><a class="code" href="classOgre_1_1Viewport.html#a1a763caddecc5e3d49b72bbd8726ce2">00323</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mRQSequenceName;
<a name="l00324"></a><a class="code" href="classOgre_1_1Viewport.html#8b082dd8109b00852809d8ca821dbccb">00324</a>         <a class="code" href="classOgre_1_1RenderQueueInvocationSequence.html" title="Class to hold a linear sequence of RenderQueueInvocation objects.">RenderQueueInvocationSequence</a>* mRQSequence;
<a name="l00326"></a><a class="code" href="classOgre_1_1Viewport.html#cbe0e8aaceb85d46ace547d5f5204090">00326</a>         <a class="code" href="namespaceOgre.html#f73bbdc8bed8a3e6fcd56bb8fa188c45">String</a> mMaterialSchemeName;
<a name="l00327"></a>00327     };
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 <span class="preprocessor">#endif</span>
</pre></div><hr>
<p>
Copyright &copy; 2000-2005 by The OGRE Team<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/"><img alt="Creative Commons License" border="0" src="http://creativecommons.org/images/public/somerights20.png"/></a><br/>
This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/2.5/">Creative Commons Attribution-ShareAlike 2.5 License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Mon Jun 16 12:48:57 2008
</p>
</body>
</html>
